;--------------------------------------------------
;  12-25-2009  - This code gives 2 errors:
;                ppd PRINTDLGEX <>   syntax error -  ppd
;                PRINTDLGEX STRUCT    error fatal error  a1016: internal assembler error
; sample just as far as Document properties windows to appear
; program should compile to show errors

comment |
.686
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\winspool.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\winspool.lib
|
;-----------------------------------------------
; CHANGED ABOVE TO THIS SO CAN USE MACROS, ETC:
;-----------------------------------------------
include \masm32\include\masm32rt.inc
include \masm32\include\winspool.inc
includelib \masm32\lib\winspool.lib

; MOVED STRUCTURE TO HERE, ABOVE THE DATA SECTION:

PRINTDLGEX       STRUCT
lStructsize            dd ?    ; size of structure in bytes 1
hwndOwner              dd ?    ; caller's window handle     2
hDevMode               dd ?    ; handle to DevMode          3
hDevNames              dd ?    ; handle to DevNames         4
hDC                    dd ?    ; printer dc/ic or null      5
Flags                  dd ?    ; PD Flags                   6
Flags2                 dd ?    ; reserved                   7
ExclusionFlags         dd ?    ; items to exclude from driver pages  8
nPageRanges            dd ?    ; number of page ranges               9
nMaxPageRanges         dd ?    ; Max number of page ranges          10
lpPageRanges           dd ?    ; array of page ranges               11
nMinPage               dd ?    ; min page number                    12
nMaxPage               dd ?    ; max page number                    13
nCopies                dd ?    ; number of copies                   14
hInstance              dd ?    ; instance handle                    15
lpPrinterTemplateName  dd ?    ; template name for app specific area  16
lpCallback             dd ?    ; app callback interface               17
nPropertyPages         dd ?    ; number of app property pages in lphPropertyPages  18
lphPropertyPages       dd ?    ; array of app property page handles                19
nStartPage             dd ?    ; start page id                                     20
dwResultAction         dd ?    ; result action if S OK is returned                 21
PRINTDLGEX           ENDS

WinMain                PROTO :DWORD,:DWORD,:DWORD,:DWORD

; PROTO IS FOR FUNCTIONS OR PROCEDURES:
;PRINTDLGEX             PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,\
;                             :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD,\
;                             :DWORD, :DWORD, :DWORD

.data

;ppd PRINTDLGEX <> ; <---- NOT USED, CONFLICTS WITH LOCAL IN WNDPROC

AppName          db   "Bridge Tallies Screen Program - testprint.exe",0
msg1             db   'Print Dialog returned an error...'
msg2             db   'Print Dialog was canceled or closed...'
msg3             db   'Press any key to exit...'
_START_PAGE_GENERAL  equ 0ffffffffh  ; <---- CHANGED CASE

szDisplayName     db "DisplayName",0   ; <---- ADDED
szDefaultPrinter  db 100 dup(0) ; <---- ADDED
rval              dd 0


doci             DOCINFO <sizeof DOCINFO, AppName, NULL, NULL, 0>

.data?
CommandLine LPSTR     ?
hdcPrn      HDC       ?
hInstance   HINSTANCE ?
RR          RECT      {?}

holdleft    dd ?        ;<---- ADDED
holdtop     dd ?        ;<---- ADDED
holdright   dd ?        ;<---- ADDED
holdbottom  dd ?        ;<---- ADDED
savemiddleofX dd ?      ;<---- ADDED

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX, msg: MSG, hwnd: HWND, hBrush: DWORD, hdc: HDC, rr: RECT

LOCAL colorbk:COLORREF          ; <---- ADDED


	mov   wc.cbSize, SIZEOF WNDCLASSEX
	mov   wc.style, CS_BYTEALIGNWINDOW
 	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInst
	pop   wc.hInstance
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
      invoke LoadCursor, NULL,IDC_ARROW
	mov   wc.hCursor, eax
	invoke CreateSolidBrush, colorbk          ; background color
      mov   hBrush, eax
	mov   wc.hbrBackground, eax
	mov   wc.lpszMenuName, NULL
	mov   wc.lpszClassName, OFFSET szDisplayName
	mov   wc.hIconSm, 0
	invoke RegisterClassEx, addr wc
      invoke SystemParametersInfo, SPI_GETWORKAREA, 0, addr RR, 0
      mov eax, RR.left
      mov holdleft, eax
      mov eax, RR.right
      mov holdright, eax
      mov eax, RR.bottom
      mov holdbottom, eax
      mov eax, RR.top
      mov holdtop, eax
      push edx               ;  this code sets up cxclient/cyclient for all chords
      push ebx
      xor edx, edx
      mov eax, holdright     ; find middle of line
      mov ebx, 2
      div ebx
      mov savemiddleofX, eax  ; middle of screen - save for all chords
      pop ebx
      pop edx
	INVOKE CreateWindowEx, NULL, ADDR szDisplayName, ADDR AppName,\
           WS_OVERLAPPEDWINDOW, RR.left, RR.top, RR.right,\
           RR.bottom, NULL, NULL, hInst, NULL
      mov   hwnd, eax

	INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd

      StartLoop:
          INVOKE GetMessage, ADDR msg, NULL, 0, 0
          cmp eax, 0
          je ExitLoop
          INVOKE TranslateMessage, ADDR msg
          INVOKE DispatchMessage, ADDR msg
          jmp StartLoop
       ExitLoop:
          mov eax, msg.wParam
          ret
WinMain ENDP

WndProc PROC  hWnd:HWND, iMsg:UINT, wParam:WPARAM, lParam:LPARAM
        LOCAL hdc: HDC, hInst: HINSTANCE, ps:PAINTSTRUCT
        LOCAL hMemory: DWORD, stm:SYSTEMTIME, hBrush: dword, rr: RECT
        LOCAL ppd: PRINTDLGEX

LOCAL dwNeeded:DWORD      ; <---- ADDED
LOCAL dwReturned:DWORD    ; <---- ADDED
LOCAL pinf04:DWORD        ; <---- ADDED
LOCAL saveeax:DWORD       ; <---- ADDED
LOCAL saveax:DWORD        ; <---- ADDED

       mov   eax,iMsg

       .IF eax==WM_CREATE
          push ebx
          invoke  EnumPrinters, PRINTER_ENUM_LOCAL, NULL, 4, NULL, \
                    0, ADDR dwNeeded, ADDR dwReturned	; Find how much memory we need (dwNeeded)
	    invoke  GlobalAlloc, GHND, dwNeeded
	    mov	    hMemory, eax

	    invoke  GlobalLock, eax	; Lock the memory block & return pointer to memory
	    mov	    pinf04, eax		; Save it
	    mov	    ebx,eax		; Set reg to memory
          invoke  EnumPrinters, PRINTER_ENUM_LOCAL, NULL, 4, pinf04, \
                                  dwNeeded, ADDR dwNeeded, ADDR dwReturned

print str$(eax),13,10  ; DISPLAYS NON-ZERO SO ABOVE PROBABLY OK

;---------------------------------------------------------
; THE FOLLOWING DISPLAYS THE NAME OF THE DEFAULT PRINTER:
;---------------------------------------------------------
print PRINTER_INFO_4.pPrinterName[ebx],13,10
;-------------------------------------------------------
; FOR WINDOWS 2000 AND LATER YOU CAN GET THE SAME NAME,
; WITH LESS CODE, BY CALLING GetDefaultPrinter
;-------------------------------------------------------
mov rval, sizeof szDefaultPrinter
invoke GetDefaultPrinter, addr szDefaultPrinter, addr rval
print str$(eax),13,10
print str$(rval),13,10
print addr szDefaultPrinter,13,10

	    invoke  CreateDC, NULL, PRINTER_INFO_4.pPrinterName[ebx], NULL, NULL
	    mov	    hdcPrn,eax
	    mov	    hdc,eax

print hex$(hdc),13,10  ; DISPLAYS NON-ZERO SO ABOVE PROBABLY OK

	    invoke  GlobalUnlock, hMemory	; Invalidate pointer to memory block
	    invoke  GlobalFree, hMemory		; Free the memory
          invoke Rectangle, hdc, 0, 0, holdright, holdbottom   ; rectangle boundries

; here we set the user printer preferences
          invoke RtlZeroMemory, addr ppd, sizeof ppd
          push sizeof ppd
          pop ppd.lStructsize
          mov eax, hWnd
          mov ppd.hwndOwner, eax

          ;-----------------------------------------------------
          ; THE RtlZeroMemory CALL SETS ALL MEMBERS TO ZERO, SO
          ; THERE IS NO NEED TO LOAD ZERO IN THE CODE BELOW.
          ;-----------------------------------------------------

          ;----------------------------------------------------
          ; THERE IS SOME SORT OF ERROR IN THIS CODE THAT WILL
          ; PREVENT THE DIALOG FROM OPENING:
          ;----------------------------------------------------

          COMMENT |
          mov ppd.hDevMode, 0h
          mov ppd.hDevNames, 0h
          mov ppd.Flags, PD_USEDEVMODECOPIESANDCOLLATE or PD_RETURNDC
          mov ppd.nCopies, 01h
          mov ppd.nPageRanges, 0ffffh
          mov ppd.nMaxPageRanges, 0ffffh
          mov ppd.nMinPage, 01h
          mov ppd.nMaxPage, 0ffffh
          |

          mov ppd.Flags, PD_RETURNDC or PD_NOPAGENUMS

          mov ppd.nStartPage, _START_PAGE_GENERAL

          invoke PrintDlgEx, addr ppd

            mov saveeax, eax
           .if eax == 0
             invoke CommDlgExtendedError
             .if eax
               invoke MessageBox, hWnd, ADDR msg1, ADDR msg1, MB_OK
               jmp GetOut2
             .elseif
               invoke MessageBox, hWnd, ADDR msg2, ADDR msg2, MB_OK
               jmp  GetOut2
             .elseif
               invoke MessageBox, hWnd, ADDR msg3, ADDR msg3, MB_OK
               jmp  GetOut2
             .endif
           .endif
           mov eax, saveax
           .if eax == PD_RESULT_APPLY
              ; NOT SURE WHERE THIS JUMP IS SUPPOSED TO GO:
              ;jmp @F
           .elseif eax == PD_RESULT_CANCEL
              jmp GetOut2
           .endif
          pop ebx

      .ELSEIF eax==WM_PAINT

CkPaintSwh:
         invoke BeginPaint, hWnd, ADDR ps
         mov hdc, eax
GetOut2:
  	.ELSEIF eax==WM_DESTROY
         invoke PostQuitMessage,NULL
         ret 0
	.ENDIF
      invoke DefWindowProc, hWnd, iMsg, wParam, lParam
	ret

    GetOut:
      invoke ReleaseDC,    hWnd, hdc
      ret

WndProc ENDP

end start
